Index: /trunk/SophyaLib/SkyMap/fiolocalmap.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/fiolocalmap.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/fiolocalmap.cc	(revision 2869)
@@ -227,4 +227,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class FIO_LocalMap<int_4>;
 template class FIO_LocalMap<r_4>;
@@ -232,3 +233,4 @@
 template class FIO_LocalMap< complex<r_4> >;
 template class FIO_LocalMap< complex<r_8> >;
+}
 #endif
Index: /trunk/SophyaLib/SkyMap/fiosphereecp.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/fiosphereecp.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/fiosphereecp.cc	(revision 2869)
@@ -139,4 +139,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class FIO_SphereECP<int_4>;
 template class FIO_SphereECP<r_8>;
@@ -144,4 +145,5 @@
 template class FIO_SphereECP< complex<r_4> >;
 template class FIO_SphereECP< complex<r_8> >;
+}
 #endif
 
Index: /trunk/SophyaLib/SkyMap/fiospherehealpix.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/fiospherehealpix.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/fiospherehealpix.cc	(revision 2869)
@@ -171,4 +171,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class FIO_SphereHEALPix<int_4>;
 template class FIO_SphereHEALPix<r_8>;
@@ -176,3 +177,4 @@
 template class FIO_SphereHEALPix< complex<r_4> >;
 template class FIO_SphereHEALPix< complex<r_8> >;
+}
 #endif
Index: /trunk/SophyaLib/SkyMap/fiospherethetaphi.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/fiospherethetaphi.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/fiospherethetaphi.cc	(revision 2869)
@@ -189,4 +189,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class FIO_SphereThetaPhi<int_4>;
 template class FIO_SphereThetaPhi<r_8>;
@@ -194,3 +195,4 @@
 template class FIO_SphereThetaPhi< complex<r_4> >;
 template class FIO_SphereThetaPhi< complex<r_8> >;
+}
 #endif
Index: /trunk/SophyaLib/SkyMap/localmap.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/localmap.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/localmap.cc	(revision 2869)
@@ -960,4 +960,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class LocalMap<int_4>;
 template class LocalMap<r_8>;
@@ -965,3 +966,4 @@
 template class LocalMap< complex<r_8> >;
 template class LocalMap< complex<r_4> >;
+}
 #endif
Index: /trunk/SophyaLib/SkyMap/mapoperation.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/mapoperation.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/mapoperation.cc	(revision 2869)
@@ -80,6 +80,6 @@
   
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
-template class MapOperations<r_4>;
-template class MapOperations<r_8>;
+template class SOPHYA::MapOperations<r_4>;
+template class SOPHYA::MapOperations<r_8>;
 #endif
    
Index: /trunk/SophyaLib/SkyMap/sphereecp.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/sphereecp.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/sphereecp.cc	(revision 2869)
@@ -429,4 +429,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class SphereECP<int_4>;
 template class SphereECP<r_4>;
@@ -434,4 +435,5 @@
 template class SphereECP< complex<r_4> >;
 template class SphereECP< complex<r_8> >;
+}
 #endif
 
Index: /trunk/SophyaLib/SkyMap/spherehealpix.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 2869)
@@ -704,4 +704,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class SphereHEALPix<uint_2>;
 template class SphereHEALPix<int_4>;
@@ -710,4 +711,5 @@
 template class SphereHEALPix< complex<r_4> >;
 template class SphereHEALPix< complex<r_8> >;
+}
 #endif
 
Index: /trunk/SophyaLib/SkyMap/spherethetaphi.cc
===================================================================
--- /trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 2868)
+++ /trunk/SophyaLib/SkyMap/spherethetaphi.cc	(revision 2869)
@@ -850,4 +850,5 @@
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
+namespace SOPHYA {
 template class SphereThetaPhi<int_4>;
 template class SphereThetaPhi<r_8>;
@@ -855,3 +856,4 @@
 template class SphereThetaPhi< complex<r_4> >;
 template class SphereThetaPhi< complex<r_8> >;
+}
 #endif